package grafika;

import java.util.Vector;

import javax.swing.table.AbstractTableModel;

import logika.Skore;
import logika.SkoreNacitac;
import logika.SortedList;

/*******************************************************************************
 * Trida ModelSkore - vytváří rozložení a logiku tabulky skore
 * 
 * @author    Michal Hron
 * @version   18.05.2012
 */
public class ModelSkore extends AbstractTableModel {
	public static final int HRAC_INDEX = 0;
	public static final int SKORE_INDEX = 1;

	protected SortedList<Skore> dataVector;

    /***************************************************************************
     * Konstruktor vytvari seznam.
     */
	public ModelSkore() {
		dataVector = SkoreNacitac.parseFile("score.txt"); //Jak sakra relativní??????????????) Mě funguje jen C:/ ...
	}

    /***************************************************************************
     * Metoda pojmenovava sloupce
     * @param sloupec
     * @return nazvySloupcu
     */
	public String getColumnName(int sloupec) {
		switch (sloupec) {
		case 0: 
			return "Jméno";
		case 1: 
			return "Skóre";
		default: 
			return "";
		}
	}

    /***************************************************************************
     * Metoda urcuje editovatelnost radku, sloupcu
     * @param radek, sloupec
     * @return false
     */
	public boolean isCellEditable(int radek, int sloupec) {
		return false;
	}

    /***************************************************************************
     * Metoda určuje příslušnost typů
     * @param sloupec
     * @return urceny typ
     */
	public Class getColumnClass(int sloupec) {
		switch (sloupec) {
		case HRAC_INDEX:
			return String.class;
		case SKORE_INDEX:
			return Integer.class;
		default:
			return Object.class;
		}

	}

    /***************************************************************************
     * Metoda urcuje vypis a jeho rozdeleni
     * @param radek, sloupec
     * @return urceny popis(jmenoHrace + hracovoSkore)
     */
	public Object getValueAt(int radek, int sloupec) {
		Skore skore12 = dataVector.get(radek);
		switch (sloupec) {
		case HRAC_INDEX:
			return skore12.getJmenoHrace();
		case SKORE_INDEX:
			return skore12.getHracovoSkore();
		default:
			return new Object();
		}
	}

    /***************************************************************************
     * Metoda urcuje pocet radek
     * @return pocet radek
     */
	public int getRowCount() {
		/*
		 * NEJAK OSETRIT - NEJDRIV SETRIDIT !!!
		 * 
		if(dataVector.size() > 10){ //aby se zobrazilo jen 10 nejlepších(kolik je libo)
			dataVector.setSize(10);
		}
		*/
		return dataVector.size();
	}

    /***************************************************************************
     * Metoda urcuje pocet sloupcu
     * @return pocet sloupcu = 2
     */
	public int getColumnCount() {
		return 2;
	}

    /***************************************************************************
     * Metoda urcuje jestli je prazdny radek
     * @return false
     */
	public boolean hasEmptyRow() {
		return false;
	}

    /***************************************************************************
     * Metoda prida dalsi zaznam
     */
	public void addEmptyRow() {
		dataVector.add(new Skore("", 0));
		fireTableRowsInserted(dataVector.size() - 1, dataVector.size() - 1);
	}
	
	//JESTLI TATO TRIDA VUBEC BUDE
	//NEJAK MOC SLOZITY - SRAT NA TO
	public void setridSkore() {
		;
	}
}
