package logika;


import java.awt.List;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Comparator;
import java.util.Scanner;

/*******************************************************************************
 * Trida SkoreNacitac -  trida nacita data ze souboru do vypisSkore(jako Skore(trida)), tedy do tabulky skore.
 * 
 * @author    Michal Hron
 * @version   18.05.2012
 */
public class SkoreNacitac {

	public static SortedList<Skore> parseFile(String nazevSouboru) {
		SortedList<Skore> vypisSkore = new SortedList<Skore>(new Comparator<Skore>() {

            @Override
            public int compare(Skore o1, Skore o2) {
                return  new Integer(o1.getHracovoSkore()).compareTo(new Integer(o2.getHracovoSkore()));
            }

        });

		File file = new File(nazevSouboru);

		try {

			Scanner scanner = new Scanner(file);
			while (scanner.hasNextLine()) {
				String line = scanner.nextLine();
				String[] split = line.split(" ");
				vypisSkore.add(new Skore(split[0], Integer.parseInt(split[1])));
			}
			
		} catch (ArrayIndexOutOfBoundsException e) {
			e.printStackTrace();
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

		return vypisSkore;
	}

}
