package logika;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class SortedList<E> extends ArrayList<E> {

    private Comparator<E> comparator1;

    public SortedList(Comparator<E> comparator) {
        this.comparator1 = comparator;
    }

    public boolean add(E e) {
        boolean ret = super.add(e);
        if (ret) {
            Collections.sort(this, comparator1);
        }
        return ret;
    }

    @Override
    public boolean remove(Object o) {
        boolean ret = super.remove(o);
        if (ret) {
            Collections.sort(this, comparator1);
        }
        return ret;
    }

}
